import objc
from AppKit import *
from GlyphsApp import *
from GlyphsApp.plugins import *


class TestTokenPlugin(PalettePlugin):
    dialogName = "net.addpixel.TestTokenPlugin"
    dialog = objc.IBOutlet()
    tokenField = objc.IBOutlet()
    menu = None

    @objc.python_method
    def settings(self):
        self.name = "Test"
        self.loadNib('IBdialog', __file__)

    @objc.python_method
    def start(self):
        self.tokenField.setDelegate_(self)

        # the next line enables the compact token display form
        self.tokenField.setTokenStyle_(3)

        Glyphs.addCallback(self.update, UPDATEINTERFACE)

    @objc.python_method
    def update(self, sender):
        pass

    @objc.python_method
    def __del__(self):
        Glyphs.removeCallback(self.update)

    @objc.python_method
    def __file__(self):
        """Please leave this method unchanged"""
        return __file__

    def tokenField_hasMenuForRepresentedObject_(self, tokenField, tag):
        return True

    def tokenField_menuForRepresentedObject_(self, tokenField, tag):
        self.menu = NSMenu.new()

        item = NSMenuItem.new()
        item.setTitle_("Test Text")
        self.menu.addItem_(item)

        return self.menu
